/*
 * uart.c
 *
 * Created: 4/6/2022 11:25:56 AM
 *  Author: Admin
 */ 

#include "uart.h"
//#include "p_f.h"

void uart_init( void ){
	#ifdef B_R_115200
	UCSR0A |= (1<<U2X0);
	#endif
   // 0.1. UBRR0 = (unsigned char)BAUD_PRESCALE;         // Set baud rate: Load the UBRR register
   UBRR0 = (unsigned int)BAUD_PRESCALE;                 // Set baud rate: Load the UBRR register
   UCSR0C = (1<<UCSZ01)|(1<<UCSZ00);                     // Set format: 8data, 1stop bit 

   UCSR0B = (1 << RXEN0) | (1 << TXEN0);                 // Enable receiver and transmitter
};

     
 int uart_putchar( const char c){
   if (c == '\n'){
	  uart_putchar( '\r' );
	  while ( !( UCSR0A & (1<<UDRE0)) );
	/* Put data into buffer, sends the data */
	UDR0 = c;
   return 0;
  }

   while ( !( UCSR0A & (1<<UDRE0)) );                  // Wait for empty transmit buffer 
	   // Do nothing until UDR is ready for more data to be written to it

      UDR0 = c;                             // Echo back the modified received byte 
return 0;
};

void uart_puts( const char *s );
// treba dorobit

char uart_getc( void ){
	while (!(UCSR0A & (1 << RXC0)) );              // Wait for data to be received 
	    // Do nothing until data have been recieved and is ready to be read from UDR
      return(UDR0);                               // Fetch the recieved byte 
};
